/*
 * Copyright 2009 Lari Natri <lari.natri@gmail.com>
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 * 
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 * 
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package compid.sequences;

/**
 * Represents a gap component used in alignments.
 * @author Lari Natri
 */
public class GapComponent extends Component
{

    private static final GapComponent gapComponent = new GapComponent();
    private final char symbol = '-';
    private final String name = "gap";

    @Override
    public boolean isCompatible(Component other)
    {
        if (other == null) {
            return false;
        } else {
            return true;
        }
    }

    @Override
    public boolean equals(Object other)
    {
        if (other.getClass() == this.getClass()) {
            return true;
        } else {
            return false;
        }
    }

    @Override
    public boolean equalsLoosely(Component other)
    {
        return this.equals(other);
    }

    @Override
    public int hashCode()
    {
        return 1;
    }

    @Override
    public String getName()
    {
        return this.name;
    }

    @Override
    public String toString()
    {
        return "" + this.symbol;
    }

    public static GapComponent createGapComponent()
    {
        return gapComponent;
    }
}
